package Flash;

use strict;
use Carp;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK $AUTOLOAD);

require Exporter;
require DynaLoader;
require AutoLoader;

@ISA = qw(Exporter DynaLoader);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(
	FlashBSDown
	FlashBSHitTest
	FlashBSOver
	FlashBSUp
	FlashButtonEnter
	FlashButtonExit
	FlashIdletoOverDown
	FlashIdletoOverUp
	FlashMenuEnter
	FlashMenuExit
	FlashModColor
	FlashModMatrix
	FlashOutDowntoIdle
	FlashOutDowntoOverDown
	FlashOverDowntoIdle
	FlashOverDowntoOutDown
	FlashOverDowntoOverUp
	FlashOverUptoIdle
	FlashOverUptoOverDown
	FlashTypeMenuButton
	FlashTypePushButton
);
$VERSION = '0.007';

sub AUTOLOAD {
    # This AUTOLOAD is used to 'autoload' constants from the constant()
    # XS function.  If a constant is not found then control is passed
    # to the AUTOLOAD in AutoLoader.

    my $constname;
    ($constname = $AUTOLOAD) =~ s/.*:://;
    my $val = constant($constname, @_ ? $_[0] : 0);
    if ($! != 0) {
	if ($! =~ /Invalid/) {
	    $AutoLoader::AUTOLOAD = $AUTOLOAD;
	    goto &AutoLoader::AUTOLOAD;
	}
	else {
		croak "Your vendor has not defined Flash macro $constname";
	}
    }
    eval "sub $AUTOLOAD { $val }";
    goto &$AUTOLOAD;
}

bootstrap Flash $VERSION;

# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

Flash - Perl extension for Flash libswf.a

=head1 SYNOPSIS

  use Flash;

=head1 DESCRIPTION

Flash is a gives you PERL access to libswf.a as programmed by Paul Haeberli.
To obtain the library go to http://reality.sgi.com/grafica/flash/

This has now been modifed by me for my own nefarious uses but
it is based on code by The Labs (http://the-labs.com/FlashPerl/).

It is part of a suite of SWF manipulation modules, Flash::*, for the 
analysis, creation, decomposition and general hacking of Shockwave Flash
movies, by Simon Wistow

=head1 AUTHOR

Simon Wistow <simon@twoshortplanks.com>,
orginally by Rene K. Mueller <kiwi@the-labs.com>

=head1 SEE ALSO

perl(1), Flash::Object, Flash::*.

=cut
